﻿using System;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA.Discovery;

namespace OpcLabs.EasyOpcFactory.UA.Discovery
{
    static public class UADiscoveryElementInstances
    {
        [NotNull]
        static public UADiscoveryElement Instance0 => new UADiscoveryElement();

        [NotNull]
        static public UADiscoveryElement Instance1 => new UADiscoveryElement(
            UAApplicationTypes.ClientOrServer,
            "discoveryUriString1",
            "applicationName1",
            "productUriString1",
            "applicationUriString1",
            "discoveryProfileUriString1",
            "gatewayServerUriString1");

        [NotNull]
        static public UADiscoveryElement Instance2 => new UADiscoveryElement(
            "testServerName",
            "testDiscoveryURL",
            new[] {"DA", "AC"});


        [NotNull]
        static public UADiscoveryElement Instance3 => new UADiscoveryElement(
            "testServerName",
            "testDiscoveryURL",
            new[] {"DA", "AC"})
        {
            EndpointUriString = "endpointUri"
        };

        [NotNull]
        static public UADiscoveryElement Instance4 => new UADiscoveryElement(
            "testServerName",
            "testDiscoveryURL",
            new[] { "DA", "AC" })
        {
            EndpointUriString = "endpointUri",
            EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1
        };

        [NotNull]
        static public UADiscoveryElement Instance5 => new UADiscoveryElement(
            "testServerName",
            "testDiscoveryURL",
            new[] { "DA", "AC" })
        {
            EndpointUriString = "endpointUri",
            EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1,
            ServerCertificateByteArray = new Byte[] { 123, 234}
        };
    }
}

