﻿using JetBrains.Annotations;
using OpcLabs.BaseLibFactory.IdentityModel.User;
using OpcLabs.EasyOpc.UA.Engine;

namespace OpcLabs.EasyOpcFactory.UA.Engine
{
    static public class UAEnhancedSessionParametersInstances
    {
        [NotNull]
        static public UAEnhancedSessionParameters Instance1 => new UAEnhancedSessionParameters
        {
            EndpointDescriptionChecks = UAEndpointDescriptionChecksInstances.Instance1,
            AcknowledgedMessagesLimit = 1002,
            AllowEndpointDomainPrompt = false,
            AlwaysPreselectEndpoint = true,
            CheckAvailableSequenceNumbers = true,
            CheckBrowseResults = true,
            CheckEndpointDomain = true,
            CheckNotificationMessage = true,
            CheckSessionId = true,
            CloseTimeout = 1003,
            DiagnosticsMasks = UADiagnosticsMasks.AdditionalInfo,
            EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1,
            EndpointSelectionTimeout = 1004,
            KeepAliveInterval = 1005,
            KeepAliveIntervalDebug = 1006,
            LocaleId = "testLocaleId1",
            PendingMessagesLimit = 1007,
            RequireMatchingServerSoftwareCertificates = true,
            RequireNonEmptyServerSignature = true,
            RequireServerEndpointsMatchDiscovery = true,
            RequireTimestampsAsRequested = true,
            RequireUniqueAuthenticationToken = true,
            RequireUniqueServerNonce = true,
            RequireValidAuthenticationToken = true,
            RequireValidServerNonce = true,
            RetrialDelay = 1001,
            SanitizeReferenceDescriptions = true,
            SessionConnectTimeout = 1008,
            SessionTimeout = 1009,
            ShortestAllowedRevisedSessionTimeout = 1010.5,
            UpdateEndpointBeforeConnect = true,
            UserIdentity = UserIdentityInstances.Instance1,
            //UserTokenSelectionPolicy = 

            ServerShutdownRetrialDelay = 2001,
            StatusSubscriptionSamplingInterval = 2002,
        };
    }
}
