﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.UnitTestLib
{
    static public class StringAssertUtilities
    {
        static public void AreEqual(string expected, string actual)
        {
            if ((expected == null) || (actual == null))
            {
                Assert.AreEqual(expected, actual);
                return;
            }
            if (actual == expected)
                return;
            int i;
            for (i = 0; i < Math.Min(actual.Length, expected.Length); i++)
            {
                if (actual[i] != expected[i])
                    break;
            }
            Assert.AreEqual(
                expected, 
                actual,
                $"First difference at: {i}.");  // IMPROVE: dump the common part, and then the expected and actual remainder
        }
    }
}
