﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Generic.Extensions;

namespace OpcLabs.BaseLibTest.Collections.Generic.Extensions
{
    // ReSharper disable once InconsistentNaming
    partial class IEnumerableExtensionTest
    {
        [TestMethod]
        public void JoinLinesTest_0()
        {
            var lines = new string[0];
            string result = lines.JoinLines();
            Assert.AreEqual("", result);
        }

        [TestMethod]
        public void JoinLinesTest_1()
        {
            var lines = new[] { "first" };
            string result = lines.JoinLines();
            Assert.AreEqual("first" + Environment.NewLine, result);
        }

        [TestMethod]
        public void JoinLinesTest_2()
        {
            var lines = new[] { "first", "second" };
            string result = lines.JoinLines();
            Assert.AreEqual("first" + Environment.NewLine + "second" + Environment.NewLine, result);
        }

        [TestMethod]
        public void JoinLinesTest_3()
        {
            var lines = new[] { "first", "second", "third" };
            string result = lines.JoinLines();
            Assert.AreEqual("first" + Environment.NewLine + "second" + Environment.NewLine + "third" + Environment.NewLine, result);
        }
    }
}
