﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.ComponentModel.Linking;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.LiveMapping._Testers
{
    class StaticEventTester
    {
        [DAType, DASubscription(RequestedUpdateRate = 100)]
        private class StaticEventTestType
        {
#pragma warning disable 67
            [DANode(ItemId = LegacyTestDefs.DataAccess.ItemIds.Incrementing_1s), DAItem(ItemType = typeof(int))]
            static public event TargetDataEventHandler<int, StaticEventTestType> IncrementingEvent;
#pragma warning restore 67
        }

        public void Test()
        {
            const int timeout = 10 * 1000;
            const int period = 1000;

            int count = 0;

            var clientMapper = new DAClientMapper();
            var testTarget = new StaticEventTestType();
            // ReSharper disable PossibleNullReferenceException
            StaticEventTestType.IncrementingEvent += ((_, args) => Console.WriteLine(args.Data));
            StaticEventTestType.IncrementingEvent += ((_, args) => count++);
            // ReSharper restore PossibleNullReferenceException

            clientMapper.Map(testTarget, new DAMappingContext { ServerDescriptor = LegacyTestDefs.ProgIds.KitServer });

            clientMapper.Subscribe(true);
            AssertUtilities.WaitingPhase(timeout);
            clientMapper.Subscribe(false);

            Assert.IsTrue(count >= timeout/period/2);
        }
    }
}
