﻿
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment
{
    // UaCppServer (Unified Automation)

    // ReSharper disable once InconsistentNaming
    public class UnifiedAutomation_UaCppServer : UAServer
    {
        public class EndpointDescriptorsInfo
        {
            public EndpointDescriptorsInfo([NotNull] UnifiedAutomation_UaCppServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public UAEndpointDescriptor OpcTcp => new UAEndpointDescriptor(_parent._endpointUrlStrings.OpcTcp);

            [NotNull]
            private readonly UnifiedAutomation_UaCppServer _parent;
        }



        private class EndpointUrlStringsInfo
        {
            public EndpointUrlStringsInfo([NotNull] UnifiedAutomation_UaCppServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public string OpcTcp => "opc.tcp://" + _parent.HostName + ":48010";

            [NotNull]
            private readonly UnifiedAutomation_UaCppServer _parent;
        }



        public UnifiedAutomation_UaCppServer([NotNull] string hostName)
            : base(hostName)
        {
            EndpointDescriptors = new EndpointDescriptorsInfo(this);
            _endpointUrlStrings = new EndpointUrlStringsInfo(this);
        }

        public override IEnumerable<UAEndpointDescriptor> AllEndpointDescriptors
        {
            get
            {
                yield return EndpointDescriptors.OpcTcp;
            }
        }

        [NotNull]
        public readonly EndpointDescriptorsInfo EndpointDescriptors;

        [NotNull]
        private readonly EndpointUrlStringsInfo _endpointUrlStrings;
    }
}
