﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace
{
    public partial class AEConditionElementTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AEConditionElement CreateSerializationTarget0()
        {
            return new AEConditionElement();
        }

        [NotNull]
        public AEConditionElement CreateSerializationTarget1()
        {
            var conditionElement = new AEConditionElement
            {
                Name = "TestName1",
                SubconditionNames = new[] { "TestSubconditionName11", "TestSubconditionName12", "TestSubconditionName13" }
            };
            return conditionElement;
        }

        [NotNull]
        public AEConditionElement CreateSerializationTarget2()
        {
            var conditionElement = new AEConditionElement
            {
                Name = "TestName2",
                SubconditionNames = new[] { "TestSubconditionName21", "TestSubconditionName22", "TestSubconditionName23" }
            };
            return conditionElement;
        }
    }
}
