﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents
{
    partial class EasyAEClientTest
    {
        #region Test Methods

        [TestCategory("OpcClassic")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestMethod]
        public void GetServiceTest_IDisposable()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(IDisposable));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestMethod]
        public void GetServiceTest_IEasyAEClient()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(IEasyAEClient));
        }

        //[TestCategory("OpcClassic")]
        //[TestCategory("OpcAlarmsAndEvents")]
        //[TestMethod]
        //public void GetServiceTest_IEasyAEClientDequeuing()
        //{
        //    TestSection.Arrange();
        //    IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(IEasyAEClientDequeuing));
        //}

        [TestCategory("OpcClassic")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestMethod]
        public void GetServiceTest_IEasyAEClientEnqueuing()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(IEasyAEClientEnqueuing));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestMethod]
        public void GetServiceTest_IEasyAEClientSettings()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(IEasyAEClientSettings));
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestMethod]
        public void GetServiceTest_ILicenseInfoProvider()
        {
            TestSection.Arrange();
            IServiceProviderTest.GetServiceTest(new EasyAEClient(), typeof(ILicenseInfoProvider));
        }

        //[TestCategory("OpcClassic")]
        //[TestCategory("OpcAlarmsAndEvents")]
        //[TestMethod]
        //public void GetServiceTest_Negative_IEasyAEClientProvider()
        //{
        //    TestSection.Arrange();
        //    IServiceProviderTest.GetServiceTest_Negative(new EasyAEClient(), typeof(IEasyAEClientProvider));
        //}

        #endregion
    }
}
