﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.AddressSpace.Parsing;

namespace OpcLabs.EasyOpcTest.UA.AddressSpace
{
    public partial class UAQualifiedNameTest
    {
        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestCategory("OpcUA")]
        [TestMethod]
        public void CtorTest_String_Empty()
        {
            var target = new UAQualifiedName("");
            Assert.AreEqual("", target.ExpandedText);
            Assert.IsTrue(target.IsNull);
            Assert.AreEqual(target.Name, "");
            Assert.AreEqual(target.NamespaceUriString, "");
        }

        [ExpectedException(typeof(UAQualifiedNameFormatException))]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void CtorTest_String_NoNamespaceUri()
        {
            // ReSharper disable once ObjectCreationAsStatement
            new UAQualifiedName("testExpandedText");
        }

        [TestCategory("OpcUA")]
        [TestMethod]
        public void CtorTest_String_Ok()
        {
            var target = new UAQualifiedName("nsu=testNamespaceUri;s=testName");
            Assert.AreEqual("nsu=testNamespaceUri;s=testName", target.ExpandedText);
            Assert.IsFalse(target.IsNull);
            Assert.AreEqual("testName", target.Name);
            Assert.AreEqual("testNamespaceUri", target.NamespaceUriString, "");
        }

        // ReSharper restore InconsistentNaming
        #endregion
    }
}
