﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.OperationModel
{
    public partial class EasyUADataChangeNotificationEventArgsTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static public EasyUADataChangeNotificationEventArgs CreateSerializationTarget0()
        {
            return new EasyUADataChangeNotificationEventArgs();
        }

        [NotNull]
        static public EasyUAMonitoredItemChangedEventArgs CreateSerializationTarget1()
        {
            return new EasyUADataChangeNotificationEventArgs
            {
                    Arguments =
                        new EasyUAMonitoredItemArguments(UAMonitoredItemArgumentsTest.CreateSerializationTarget1()),
                    AttributeData = UAAttributeDataTest.CreateSerializationTarget1(),
                    ErrorId = "1001"
                };
        }
    }
}
