﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Discovery;
using OpcLabs.UnitTestLib;

namespace OpcLabs.OpcInteroperabilityTest.Legacy.UA
{
    // ReSharper disable once InconsistentNaming
    public partial class EasyUAClientTest_IopWS201611
    {
        [TestMethod]
        public void InteroperabilityWorkshopTest_Gds()
        {
            TestSection.Arrange();

            var client = new EasyUAClient();
            client.InstanceParameters.GdsEndpointDescriptor.Host = "10.10.10.11";

            TestSection.Act();

            UADiscoveryElementCollection discoveryElementCollection = client.DiscoverGlobalServers();

            TestSection.Assert();

            Assert.IsNotNull(discoveryElementCollection);
            int count = discoveryElementCollection.Count;
            AssertUtilities.WriteLine($"Count: {count}");
            foreach (UADiscoveryElement discoveryElement in discoveryElementCollection)
            {
                Assert.IsNotNull(discoveryElement);

                AssertUtilities.WriteLine();
                AssertUtilities.WriteLine(discoveryElement.ApplicationOrServerName);
                AssertUtilities.WriteLine(discoveryElement.DiscoveryUriString);
                AssertUtilities.WriteLine(String.Join(",", discoveryElement.ServerCapabilities));
            }
            Assert.IsTrue(count >= 2);
        }
    }
}
