﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class ProsysOpc_Sentrol_Test : UAInteroperabilityWorkshopTest
    {
        //public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        //public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.prosysopc.com/UA/Delphi/SampleNamespace;ns=2;s=MyLevel",
            UAVariableIds.Server_ServerStatus_CurrentTime
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://DESKTOP-VLOO8CH:4842" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new string[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group003_AttributeServices_Test03_Read_MaxAge),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256),
        });

        public override string Password => "opcua";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.prosysopc.com/UA/Delphi/SampleNamespace;ns=2;s=Int32",
            "nsu=http://www.prosysopc.com/UA/Delphi/SampleNamespace;ns=2;s=Double"
        };

        public override string UserName => "opcua";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.prosysopc.com/UA/Delphi/SampleNamespace;ns=2;s=Int32",
            "nsu=http://www.prosysopc.com/UA/Delphi/SampleNamespace;ns=2;s=Double"
        };
    }
}
