﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Engine;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class RockwellAutomation_FactoryTalkLinxGateway_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.rockwellautomation.com/OpcUa ;ns=3;s=[Emulate5570]Dynamic_REAL_001",
            "nsu=http://www.rockwellautomation.com/OpcUa ;ns=3;s=[Emulate5570]Dynamic_DINT_001"
        };

        //public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://192.168.1.31:4990" };
        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://192.168.1.25:4990" };

        public override UAEndpointDescriptor EndpointDescriptorUserNameAndPassword
        {
            get
            {
                // ReSharper disable once StringLiteralTypo
                UAEndpointDescriptor endpointDescriptor = "opc.tcp://192.168.1.25:4991/FactoryTalkLinxGateway1";
                endpointDescriptor.EndpointSelectionPolicy = new UAEndpointSelectionPolicy
                {
                    SecurityPolicyUriString = UASecurityPolicyUriStrings.Basic256
                };
                return endpointDescriptor;
            }
        }

        public override string Password => "password";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),   // not given
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),    // not given
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group013_Discovery_Test04_GetEndpoints_Server),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=http://www.rockwellautomation.com/OpcUa ;ns=3;s=[Emulate5570]Static_DINT_001" };

        public override string UserName => "ftuser";
    }
}
