﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Siemens_SimaticCpu1516_3Pndp_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"IDB_Arrays_Typesafe\".\"MyIntArray_Input\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"IDB_Arrays_Typesafe\".\"MyByteArray_Input\""
        };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"IDB_Arrays_Typesafe\".\"MyIntArray_Static\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"IDB_Arrays_Typesafe\".\"MyByteArray_Static\""
        };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://opcfoundation.org/UA/ ;i=2258", // CurrentTime
            "nsu=http://opcfoundation.org/UA/ ;i=2258"  // dtto - cannot find anything else
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://10.10.100.7:4840" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group014_Challenge_Test03_LongNetworkInterruption),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "CPU1500";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyInt_M\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyByte_M\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyLReal_M\""
        };

        public override string UserName => "CPU1500";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyInt_M\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyByte_M\"",
            "nsu=http://www.siemens.com/simatic-s7-opcua ;ns=3;s=\"MyLReal_M\""
        };
    }
}
